//##=======================================================================
/****************************************************************************
*  PGVTEST.C    : Put Squares into EMS  & Print Out                         *
*               : Date ..  01/31/1992                                       *
*               : Ver. 3.0                                                  *
*               : Released From Orint Advance CO., LTD                      *
*               : All  Right Reserved                                       *
****************************************************************************/
//##=======================================================================
#include        <stdio.h>
#include        <dos.h>
#include        <memory.h>
#include        <conio.h>
#include        <stdlib.h>
#include        <string.h>
//##=======================================================================
#define A4              0x40
#define A3              0x30
#define B4              0x20
//##=======================================================================
#define EMS             0x67
#define MaxPaper        3
#define Page_Byte       16384
#define Dim             2              /* 2 Dimension */
//##=======================================================================
char *PaperSize[]= { "A4","B4","A3" };
/* Scale for Dpi ; EX. dpi=300 --> Dpi_400 = 300/400=0.75 */
float Dpi_400=1.;
/* 400 dpi dots for (A4,B4,A3) Paper */
int Dots_400[MaxPaper][Dim] ={
                                 {4552,3184},
                                 {5608,3928},
                                 {6496,4552}
                             };
char  outdata[2][860];          /* Grid Pattern Buffer */
//##=======================================================================
int Start_Page,Offset_Line,Total_Line,Total_Page,Page_Line;
int Start_Line,Start_Byte,Stop_Line,Stop_Byte;
int Page_Handle,Ems_Seg,Page_Addr,Logic_Page,Line_Byte;
int Ems_Total_Page,Ems_Avail_Page;
//##=======================================================================
int Plot_Area=6;                       /* Plot area = 6*6 inch^2 */
int Ems_Err,Result;
int dot_interval;
int dpi=400;
int Dot_Inch=10;
char Paper_Kind,Paper_Code;
//##=======================================================================
void Ems_Data()
{
  asm {
    mov         ax,0
    mov         es,ax
    mov         es,es:[67h*4+2]
    mov         ax,Line_Byte
    mov         es:[40h],ax             /* Send Line_Byte */
    mov         bx,Total_Page           /* Send Total_page */
    mov         dx,Page_Handle          /* Send Page_Handle */
    mov         ah,3dh                  /* ah= Call No */
    int         67h
  }
}
//##=======================================================================
void Clear_Ems()
{
  asm {
    mov         ah,03eh                  /* ah= Call No */
    int         67h
  }
}
//##=======================================================================
Print_Paper1()
{
  asm {
    mov         bl,Paper_Code                    /* al= Paper_Code */
    mov         ah,020h                  /* ah= Call No */
    int         67h
  }
  return _AX;
}
//##=======================================================================
Print_Paper()
{
  asm {
    mov         ah,03Fh                  /* ah= Call No */
    int         67h
  }
  return _AX;
}
//##=======================================================================
ems_seg_get()
{
  _AH=0x41;
  geninterrupt(EMS);
  return(_BX);
}
//##=======================================================================
ems_alloc(int Total_Page)
{
  _BX=Total_Page;
  _AH=0X43;
  geninterrupt(EMS);
  Page_Handle=_DX;
  return(_AH);
}
//##=======================================================================
ems_map(int Page_Handle, int Logic_Page)
{
  _BX=Logic_Page;
  _DX=Page_Handle;
  _AX=0x4400;
  geninterrupt(EMS);
  return(_AH);
}
//##=======================================================================
ems_avail()
{
  _DX=Page_Handle;
  _AH=0x42;
  geninterrupt(EMS);
  Ems_Avail_Page=_BX;
  Ems_Total_Page=_DX;
  return(_AH);
}
//##=======================================================================
ems_free(int Page_Handle)
{
  _DX=Page_Handle;
  _AH=0x45;
  geninterrupt(EMS);
  return(_AH);
}
//##=======================================================================
void wr_ems()
{
  int i,j,k,Stop_Cnt;
  char *p;
  char biter[8]={ 0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01 };

  /* Set Grid Pattern */
  for (i=0; i<(Line_Byte+1); i++) {
        if ( (Start_Byte <=i) && ( i <= Stop_Byte)) {
                outdata[0][i]=0x00;
                outdata[1][i]=0xff;
        } else {
                outdata[0][i]=0;
                outdata[1][i]=0;
    }
  }
  p=&outdata[0][Start_Byte];
  Stop_Cnt=Stop_Byte-Start_Byte+1;
  for (i=0; i<= Stop_Cnt*8; i++) {
        if ((i%dot_interval)==0)
                *(p+i/8)|=biter[i%8];
  }

  Ems_Seg = ems_seg_get();
  Logic_Page=Start_Page;
  ems_map(Page_Handle,Logic_Page);
  Page_Addr=Offset_Line * Line_Byte;

  /* Write Pattern to EMS Memory */
  for (i=0;i<(Plot_Area*dpi+1);i++)  {
    if ((i % dot_interval) == 0)
      _fmemcpy(MK_FP(Ems_Seg,Page_Addr),outdata[1],Line_Byte);
    else
      _fmemcpy(MK_FP(Ems_Seg,Page_Addr),outdata[0],Line_Byte);

    Page_Addr=Page_Addr+Line_Byte;

    if (( Page_Addr + Line_Byte ) > Page_Byte ) {
      Page_Addr = 0;
      Logic_Page = Logic_Page + 1;
      ems_map(Page_Handle,Logic_Page);
    }
  }
}
//##=======================================================================
void input_data(char *argv[])
{
  char i,prm=0;

  clrscr();
  printf("\t\t**************************************\n");
  printf("\t\t*  PageVideo Card & Ems Card Test    *\n");
  printf("\t\t*       For 300/400/600  DPI         *\n");
  printf("\t\t*  /Dxxx for DPI       (300,400,600) *\n");
  printf("\t\t*  /Pxx  for Paper Size Code (1,2,3) *\n");
  printf("\t\t*  /Rxx  for Print Area Inch         *\n");
  printf("\t\t*  /Gxx  for Dot Per Inch    (1~150) *\n");
  printf("\t\t*********DATE:%8s****JimChen**\n",__DATE__);
  for (i=1;argv[i]!=NULL;i++) {
    if (argv[i][0]=='/') {
      strupr(argv[i]);
      switch(argv[i][1]) {
        case 'D' : prm|=0x01; dpi=max(300,min(600,atoi(&argv[i][2]))); break;
        case 'P' : prm|=0x02; Paper_Kind=max(0,min(2,atoi(&argv[i][2])-1)); break;
        case 'R' : prm|=0x04; Plot_Area=max(1,min(17,atoi(&argv[i][2]))); break;
        case 'G' : prm|=0x08; Dot_Inch=max(1,min(600,atoi(&argv[i][2]))); break;
        default : break;
      }
    }
  }
  if (!(prm&0x01)) {
    printf("\n  1. 300");
    printf("\n  2. 400");
    printf("\n  3. 600");
    printf("\nPlease select Dpi:");
    scanf("%d",&i);
    switch(i) {
      case  1:  dpi=300; break;
      case  2:  dpi=400; break;
      case  3:  dpi=600; break;
    }
  }
  if (!(prm&0x02)) {
    printf("\n  1. A4");
    printf("\n  2. B4");
    printf("\n  3. A3");
    printf("\nPlease select paper size:");
    scanf("%d",&i);
    Paper_Kind=i-1;
  }

  if (!(prm&0x04)) {
    printf("\nRange: (A4: 1 -- 7) inch. ");
    printf("\n       (B4: 1 -- 9) inch. ");
    printf("\n       (A3: 1 -- 11) inch. ");
    printf("\nPlease Input Plot Length :");
    scanf("%d",&Plot_Area);
  }

  if (!(prm&0x08)) {
    printf("Please Input Grid Density Per Inch(1,2,5,10,50,150):");
    scanf("%d",&Dot_Inch);
  }
  printf("\t=================================================\n");
  printf("\t\t\t DPI        => %d\n",dpi);
  printf("\t\t\t PaperSize  => %s\n",PaperSize[Paper_Kind]);
  printf("\t\t\t PrinterArea=> %d\n",Plot_Area);
  printf("\t\t\t GridPerInch=> %d\n",Dot_Inch);
  /* Computer other parameter */
  dot_interval=dpi/max(1,min(Dot_Inch,dpi));
  Dpi_400=(float) dpi /400;
  switch(Paper_Kind) {
    case  0: Paper_Code=A4; break;
    case  1: Paper_Code=B4; break;
    case  2: Paper_Code=A3; break;
  }
  /* Select Data */
  Total_Line=Dots_400[Paper_Kind][0]*Dpi_400;
  Line_Byte=Dots_400[Paper_Kind][1]*Dpi_400/8;
  Page_Line=Page_Byte/Line_Byte;
  Total_Page=Total_Line/Page_Line+1;
  /* Caculate Data */
  if (Total_Line<dpi*Plot_Area) Start_Line=0;
  else Start_Line=Total_Line/2-dpi*Plot_Area/2;
  if (Line_Byte<dpi*Plot_Area/8)  Start_Byte=0;
  else Start_Byte=Line_Byte/2-dpi*Plot_Area/2/8;
  Stop_Byte=Start_Byte+dpi*Plot_Area/8;
  Start_Page=Start_Line/Page_Line+1;
  Offset_Line=Start_Line % Page_Line;
} /* End of input_data() */
//##=======================================================================
void main(int argc,char *argv[])
{
  input_data(argv);
  Ems_Err=ems_alloc(Total_Page);
  printf("\n\nEms_Err=%x ",Ems_Err);
  if (Ems_Err) {
    printf("\n\nEms Allocated Error ");
    switch(Ems_Err){
      case  0x88: {
        ems_avail();
        printf("\n\nEms_Total_Page=%d",Ems_Total_Page);             printf("\tEms_Avail_Page=%d",Ems_Avail_Page);
        printf("\n\nNot Enough Available Ems Pages");
      break;
      }
      case 0x87:  {
        ems_avail();
        printf("\n\nEms_Total_Page=%d",Ems_Total_Page);
        printf("\tPage_Needed=%d",Total_Page);
        printf("\n\nNot Enough Total Ems Pages");
        break;
      }
    }
  } else {
    Ems_Data();
    Clear_Ems();
    wr_ems();
    Result=Print_Paper();
    if (!Result) {
      printf("\n\nPrint OK ");
    } else {
      printf("\n\nResult_code=0x%x",Result);
      Result = Result & 0xff;
      switch(Result){
        case   0x01 :  printf("\n\nPaper Fail !!"); break;
        case   0x02 :  printf("\n\nPaper Jam !!"); break;
        case   0x03 :  printf("\n\nNo EP Cartridge !!"); break;
        case   0x04 :  printf("\n\nDoor Open !!"); break;
        case   0x05 :  printf("\n\nPrinter Power Not On !!"); break;
        case   0x06 :  printf("\n\nPaper Size Error !!"); break;
        case   0x09 :  printf("\n\nVideo Card Address Conflict !!"); break;
        case   0x0B :  printf("\n\nNo Paper Tray !!"); break;
        case   0x0C :  printf("\n\nPaper Jam !!(VSYNC time-out)"); break;
        case   0x0D :  printf("\n\nPaper Jam !!(BD-Line time-out)"); break;
        case   0x0E :  printf("\n\nPrinter no Connect !!"); break;
        case   0x0F :  printf("\n\nCommand Fail !!"); break;
      }
    }
    ems_free(Page_Handle);
  }
}
//##=======================================================================
